{ From : Aleksey Polushkin             2:50/340.7                       09.08.97
 Subj : 80x30
 Corrected by Valery Votintsev}
{$G+}
Uses CRT;
var
  VSav: record { .  video- }
          BufLen :word; {Length of Regen Buffer in Bytes}
          RowNum :byte; {Number of Rows on the Screen (Minus 1)}
          VCS    :byte; {Video Control States}
          VMode  :byte; { p }
          WindMin:word; {VV: Store WindMin}
          WindMax:word; {VV: Store WindMax}
        end;

    i:integer;

Procedure SetBlink(Mode:Boolean); Assembler;
{ 16 梥⮢ 䮭 }
asm
   mov ax,1003h
   mov bl,Mode
   int 10h           { 0 - .䮭 / 1 - 栭 }
end;


Procedure SaveVideoState;
{ save video-BIOS state }
begin
     asm
        push 0;
        pop es
        mov ax,es:[44Ch]  {Get Length of Regen Buffer in Bytes}
        mov VSav.BufLen,ax  {Save Length of Regen Buffer in Bytes}
        mov al,es:[484h]  {Get Number of Rows on the Screen (Minus 1)}
        mov VSav.RowNum,al  {Save Number of Rows on the Screen (Minus 1)}
        mov al,es:[487h]  {Get Video Control States}
        mov VSav.VCS,al  {Save Video Control States}
        mov ah,0Fh;
        int 10h;          { Get Current Video State }
        mov VSav.VMode,al { Save Current Video State }
     end;
   VSav.WindMin:=WIndMin;
   VSav.WindMax:=WIndMax;
end;

Procedure Set80x30;
{ VGA 80x30 }
begin
     asm
        push 0; pop es            { index register port adress }
        mov dx,es:[463h]          { 3B4h/3D4h  Mono/Color VGA adapters }
        sub dl,10h
        mov ax,100h
        out dx,ax
        mov ax,1
        out dx,ax
        mov ax,302h
        out dx,ax
        mov ax,3
        out dx,ax
        mov ax,204h
        out dx,ax
        sub dl,02h
        mov al,0E7h
        out dx,al
        add dl,02h
        mov ax,300h
        out dx,ax
        add dl,10h
        mov ax,0C11h
        out dx,ax
        mov ax,0B06h
        out dx,ax
        mov ax,3E07h
        out dx,ax
        mov ax,4F09h
        out dx,ax
        mov ax,0EA10h
        out dx,ax
        mov ax,8C11h
        out dx,ax
        mov ax,0DF12h
        out dx,ax
        mov ax,0E715h
        out dx,ax
        mov ax,416h
        out dx,ax
        mov al,1Dh
        mov es:[484h],al
        mov al,0FEh
        and es:[487h],al
        mov ax,12C0h
        mov es:[44Ch],ax
     end;
   {Correct the WindMin and WindMax variables (Crt unit)
    These variables are set by calls to the Window procedure.
          WindMin defines the upper left corner
          WindMax defines the lower right corner
     The X coordinate is stored in the low byte,
     and the Y coordinate is stored in the high byte}
   WindMin:=0;

   WindMax:=(29 shl 8)+79;

 end;


Procedure RestoreVGA;
 begin
      asm                     { restore video-BIOS state }
         push 0;
         pop es
         mov ax,VSav.BufLen
         mov es:[44Ch],ax
         mov al,VSav.RowNum
         mov es:[484h],al
         mov al,VSav.VCS
         mov es:[487h],al
         xor ah,ah
         mov al,VSav.VMode
         int 10h
         xor  ax,ax
         int  33h       { restore mouse }
      end;
   WindMin:=VSav.WIndMin;
   WindMax:=VSav.WIndMax;

 end;

begin
  SaveVideoState;
  Set80x30;
  For i:=1 to 29 do
    writeln(i);
  SetBlink(False);
  TextAttr:=White*16+Black;
  write('30   press <Enter> to continue');
  Readln;
  restoreVGA;
  TextAttr:=LightGray;
end.

